(in-package :movement-three)

(defstruct interval vreg start end)
(defun interval-intersects-p (interval index)
  (and (<= (interval-start interval) index)
       (< index (interval-end interval))))
(defun intervals-intersect-p (interval1 interval2)
  (and (< (interval-start interval1) (interval-end interval2))
       (< (interval-start interval2) (interval-end interval1))))
(defun interval-union (i1 i2)
  (assert (eq (interval-vreg i1) (interval-vreg i2)))
  (make-interval :vreg (interval-vreg i1)
                 :start (min (interval-start i1) (interval-start i2))
                 :end (max (interval-end i1) (interval-end i2))))

(define-time-meter *liveness* assembly liveness-analysis)
(defun compute-live-intervals (cfg)
  ;; Number each instruction.
  (with-timing (*liveness*)
    (loop with index = 0
          for b across (cfg-blocks-by-schedule cfg)
          do (dolist (i (basic-block-instructions b))
               (setf (instruction-index i) index)
               (incf index)))
    ;; Do data-flow analysis to find live intervals for each basic block.
    (let ((intervals-per-bb (make-hash-table))
          (live-out-per-bb (make-hash-table))
          (work-list (coerce (cfg-blocks-by-schedule cfg) 'list)))
      (labels ((transfer (b)
                 (let* ((live
                          (reduce #'union (basic-block-successors b)
                                  :key (lambda (b) (gethash b live-out-per-bb '()))
                                  :initial-value '()))
                        (last-index (instruction-index (first (last (basic-block-instructions b)))))
                        (live (loop for vreg in live
                                    collect (make-interval :vreg vreg :end last-index)))
                        (intervals live))
                   (loop for i in (reverse (basic-block-instructions b))
                         for index = (instruction-index i)
                         do (multiple-value-bind (use def) (instruction-uses-defs i)
                              ;; We have to process definitions first. Consider an instruction like
                              ;; ADD v0, v0, v1 which both uses and defs v0. It should first finish
                              ;; the last interval for v0 and create a new interval. (Or should it
                              ;; reuse the same interval? I'm indifferent, linear scan is
                              ;; indifferent too)
                              (dolist (d def)
                                (when (and (or (virtual-register-p d)
                                               (and (register-p d) (position d arm:*gprs*))))
                                  (let ((interval (find d live :key #'interval-vreg)))
                                    (cond
                                      ((null interval)
                                       ;; Make a bogus interval, so that we allocate some register.
                                       (push (make-interval :vreg d :start index :end index) intervals))
                                      (t
                                       (setf (interval-start interval) index
                                             live (remove interval live)))))))
                              (dolist (u use)
                                (when (and (or (virtual-register-p u)
                                               (and (register-p u) (position u arm:*gprs*)))
                                           (not (member u live :key #'interval-vreg)))
                                  (let ((interval (make-interval :vreg u :end index)))
                                    (push interval intervals)
                                    (push interval live))))))
                   (let ((first-index (instruction-index (first (basic-block-instructions b)))))
                     (dolist (l live) (setf (interval-start l) first-index)))
                   (values (mapcar #'interval-vreg live) intervals))))
        (loop until (endp work-list)
              do (let ((b (pop work-list)))
                   (multiple-value-bind (live intervals) (transfer b)
                     (setf (gethash b intervals-per-bb) intervals)
                     (unless (alexandria:set-equal live (gethash b live-out-per-bb))
                       (setf (gethash b live-out-per-bb) live)
                       (dolist (p (basic-block-predecessors b))
                         (pushnew p work-list)))))))
      (reduce #'append (alexandria:hash-table-values intervals-per-bb) :from-end t))))

(defun merge-live-intervals (intervals)
  (let ((fixed-reg-intervals '())
        (vreg-intervals (make-hash-table)))
    (dolist (i intervals)
      (etypecase (interval-vreg i)
        (virtual-register
         (let ((prior (gethash (interval-vreg i) vreg-intervals)))
           (setf (gethash (interval-vreg i) vreg-intervals)
                 (if (null prior)
                     i
                     (interval-union prior i)))))
        (register (push i fixed-reg-intervals))))
    (sort (append fixed-reg-intervals (alexandria:hash-table-values vreg-intervals))
          #'< :key #'interval-start)))

(define-time-meter *reg-alloc-time* assembly register-allocation)
(defun allocate-registers (intervals)
  (with-timing (*reg-alloc-time*)
    (let ((allocations (make-hash-table))
          (free (make-array (length arm:*gprs*) :element-type 'bit :initial-element 1))
          (fixed (make-array (length arm:*gprs*) :initial-element '()))
          (active '()))
      ;; Store fixed register intervals.
      (dolist (i intervals)
        (when (and (typep (interval-vreg i) 'register)
                   (find (interval-vreg i) arm:*gprs*))
          (push i (aref fixed (position (interval-vreg i) arm:*gprs*)))))
      (labels ((expire-old-intervals (start)
                 (setf active
                       (loop for (reg . interval) in active
                             if (< (interval-end interval) start)
                               do (setf (bit free reg) 1)
                             else collect (cons reg interval))))
               (interfered-p (n i)
                 (loop for f in (aref fixed n)
                         thereis (intervals-intersect-p i f)))
               (find-free-register (i)
                 (loop for n from 0 below (length free)
                       when (and (= 1 (bit free n)) (not (interfered-p n i)))
                         return n))
               (spill-at-interval (i)
                 (let ((spill (cdr (first active))))
                   ;; Find the interval with the last spill and with a register
                   ;; which doesn't interfere with any fixed intervals.
                   (dolist (other (rest active))
                     (when (and (> (interval-end (cdr other)) (interval-end spill))
                                (not (interfered-p (car other) i)))
                       (setf spill (cdr other))))
                   (cond
                     ;; We can end up spilling if all registers have interfering
                     ;; fixed intervals, despite ACTIVE being empty.
                     ((and (not (null spill)) (> (interval-end spill) (interval-end i)))
                      (let ((reg (gethash spill allocations)))
                        (shiftf (gethash i allocations)
                                (gethash spill allocations)
                                (stack-location))
                        (setf active (acons reg i (remove spill active :key #'cdr)))))
                     (t (setf (gethash i allocations) (stack-location)))))))
        (dolist (i intervals)
          (when (typep (interval-vreg i) 'virtual-register)
            (expire-old-intervals (interval-start i))
            (trivia:match (find-free-register i)
              (nil (spill-at-interval i))
              (chosen
               (setf (gethash i allocations) chosen
                     (bit free chosen) 0)
               (push (cons chosen i) active))))))
      (let ((result (make-hash-table)))
        (maphash (lambda (i r)
                   (setf (gethash (interval-vreg i) result)
                         (if (integerp r) (aref arm:*gprs* r) r)))
                 allocations)
        result))))

(defun apply-register-allocation (cfg intervals allocation)
  (loop with stack-slot-counter = 0
        for b across (cfg-blocks-by-schedule cfg)
        do (dolist (i (basic-block-instructions b))
             (setf (instruction-arguments i)
                   (loop for a in (instruction-arguments i)
                         collect (if (virtual-register-p a)
                                     (gethash a allocation)
                                     a))))
           (setf (basic-block-instructions b)
                 (loop for i in (basic-block-instructions b)
                       appending (reload-store-instruction i intervals allocation))))
  ;; Add prologue.
  (let ((header (aref (cfg-blocks-by-schedule cfg) 0)))
    (setf (basic-block-instructions header)
          (append (function-prologue) (basic-block-instructions header)))))
